{$M 8192,0,0}

{$R+,Q+,I+,S+,F+}

Uses Crt, Dos, SVGA;

Const
  XS = 1;
  YS = 1;
  XStep = 1;
  YStep = 1;
  MaxX = 128;
  MaxY = 128;
  RInc = ((390*XS)Div MaxX) * XStep;
  IInc = ((512*YS)Div MaxY) * YStep;

Var
  Area, Back : Array[1..MaxX, 1..MaxY]Of Byte;
  py, s,c,d, nx,ny, x,y, xp,yp, x0,y0 : Integer;

Begin
  CheckBreak := True;
  SetCBreak(True);

  Set256Mode(320, 200);

  Port[$3C8] := 1;
  For c := 1 To 63 Do {Set palette scale starting from black, till white}
  Begin
    Port[$3C9] := 15+c*32 Div 63;
    Port[$3C9] := c;
    Port[$3C9] := 0;
  End;

  FillChar(Back, SizeOf(Back), 0);
  FillChar(Area, SizeOf(Area), 0);

  y := MaxY; yp := -256*YS;
  Repeat

    x := 1; xp := -270*XS;

    Repeat
      {Fractal loop}
      x0 := 0;
      y0 := 0;
      c := 0;

      Repeat
        Inc(c);
        If c=64 Then Break;

        d := DivLong(MulLong(x0,x0) - MulLong(y0,y0), 128) + xp;
        y0 := DivLong(MulLong(x0,y0), 64) + yp;
        x0 := d
      Until MulLong(x0,x0)+MulLong(y0,y0) > 100000;
      Area[x, y] := c;

      {Plot fractal piece}
      d := (y-Random(2))*63 Div MaxY;
      For py := y-c To y Do
        If Point(x,71+py)=0 Then
          PSet(x,71+py, d);

      Inc(x, XStep);
      Inc(xp, RInc)
    Until x>=MaxX-1;

    {Make shadows for this line}
    For x := 2 To MaxX Do
    Begin
      c := Area[x, y];
      nx := x-1;
      ny := Area[nx,y];
      s := c-ny;

      If s<>0 Then
        Repeat
          For py := y-ny To y Do
            If(py>1)And(Back[nx,py]=0)Then
            Begin
              c := Point(nx,py+71)-(s Div s);
              If c<0 Then c := 0;
              If c>63 Then c := 63;
              PSet(nx,py+71, c);
              Back[nx,py] := 1
            End Else
              Delay(0);

          Dec(nx);
          If nx < 1 Then Break;

          Dec(s, 1+Area[nx,y]-ny);

          ny := Area[nx,y]
        Until(s <= 0);
    End;

    Dec(y, YStep);
    Inc(yp, IInc)
  Until y<=1;


  ReadLn
End.